//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   14 Jan 08  John Sublett  Creation
//

using sql

**
** ColDef for the Bool data type.
**
@havenCol=Bool.type
const internal class BoolCol : ColDef
{
  new make() : super.make() {}

  new makeForField(HavenService haven, Field field) : super(haven, field)
  {
  }
  
  override Str toSql(Obj o)
  {
    return ((Bool)o) ? "'t'" : "'f'"
  }
  
  override Void setFieldFromRow(Obj obj, Row row, HavenNamespace ns)
  {
    field.set(obj, row.get((Col)row.type.field(field.name)) == "t")
  }
  
  override Obj rowValue(Row row, Col col)
  {
    return row.get(col) == "t"
  }
  
  override Obj paramValue(Obj o, Str:Obj params)
  {
    v := ((Bool)o) ? "t" : "f"
    if (params != null) params[field.name] = v
    return v
  }
  
  override Str sqlType()
  {
    return "CHAR(1)"
  }
}