//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   09 Apr 08  John Sublett  Creation
//

using sql

**
** ColDef for the Buf data type.
**
@havenCol=Buf.type
const internal class BufCol : ColDef
{
  new make() : super.make() {}

  new makeForField(HavenService haven, Field field) : super(haven, field)
  {
    len = field.facet("max", null)
    if (len == null)
      throw HavenErr.make("'max' facet required for Buf fields.");
    blobType = haven.dialect.getBlobType(len)
  }
  
  override Str toSql(Obj o)
  {
    throw HavenErr.make("Cannot convert Buf to SQL.")
  }
  
  override Void setFieldFromRow(Obj obj, Row row, HavenNamespace ns)
  {
    field.set(obj, row.get((Col)row.type.field(field.name)))
  }
  
  override Obj rowValue(Row row, Col col)
  {
    return row.get(col)
  }
  
  override Str sqlType()
  {
    return blobType
  }
  
  const Str blobType
  const Int len
}