//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   9 Feb 08  John Sublett  Creation
//

using sql

**
** ColDef for the DateTime data type.
**
@havenCol=DateTime.type
const internal class DateTimeCol : ColDef
{
  new make() : super.make() {}
  
  new makeForField(HavenService haven, Field field) :super(haven, field)
  {
  }
  
  override Str toSql(Obj o)
  {
    return ((DateTime)o).ticks.toStr
  }

  override Void setFieldFromRow(Obj obj, Row row, HavenNamespace ns)
  {
    field.set(obj, DateTime.makeTicks(row.get((Col)row.type.field(field.name)), TimeZone.utc))
  }
  
  override Obj rowValue(Row row, Col col)
  {
    return DateTime.makeTicks(row.get(col), TimeZone.utc)
  }
  
  override Obj paramValue(Obj o, Str:Obj params)
  {
    v := ((DateTime)o).ticks()
    if (params != null) params[field.name] = v
    return v
  }
  
  override Str sqlType()
  {
    return "BIGINT"
  }
}