//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   14 Jan 08  John Sublett  Creation
//

using sql

**
** ColDef for the Int data type.
**
@havenCol=Int.type
const internal class IntCol : ColDef
{
  new make() : super.make() {}
  
  new makeForField(HavenService haven, Field field) :super(haven, field)
  {
  }
  
  override Str toSql(Obj o)
  {
    return ((Int)o).toStr
  }

  override Void setFieldFromRow(Obj obj, Row row, HavenNamespace ns)
  {
    field.set(obj, row.get((Col)row.type.field(field.name)))
  }
  
  override Obj rowValue(Row row, Col col)
  {
    return row.get(col)
  }
  
  override Str sqlType()
  {
    return "INTEGER"
  }
}