//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   01 Jan 08  John Sublett  Creation
//

using sql

**
** Test the DbModel class.
**
class DbModelTest : Test
{
  Void test()
  {
    build
    missingDepends
      }
  
  DbModel newModel()
  {
    model := DbModel.make
    model.addType(Chapter.type)
    model.addType(Book.type)
    model.addType(Person.type)
    model.addType(Publisher.type)
    model.commit
    
    return model
  }
  
  Void build()
  {
    model := newModel
    
    createOrder := model.listTypes
    verifyEq(createOrder[0], Person.type)
    verifyEq(createOrder[1], Publisher.type)
    verifyEq(createOrder[2], Book.type)
    verifyEq(createOrder[3], Chapter.type)
  }
  
  Void missingDepends()
  {
    model := DbModel.make
    model.addType(Chapter.type)
    model.addType(Person.type)
    model.addType(Publisher.type)

    verifyErr(HavenErr.type) |,|
    {
      model.commit
    }
  }
}