//
// Copyright (c) 2008, John Sublett
// Licensed under the Academic Free License version 3.0
//
// History:
//   01 Jan 08  John Sublett  Creation
//

using sql

**
** Test behavior of the TypeGraph.
**
class TypeGraphTest : Test
{
  Void test()
  {
    sort
    cycle
  }
  
  Void sort()
  {
    graph := TypeGraph.make
    graph.addDependency(Book.type, Person.type)
    graph.addDependency(Book.type, Publisher.type)
    graph.addDependency(Chapter.type, Book.type)
    
    types := graph.sort
    verifyEq(types[0], Person.type)
    verifyEq(types[1], Publisher.type)
    verifyEq(types[2], Book.type)
    verifyEq(types[3], Chapter.type)
  }
  
  Void cycle()
  {
    graph := TypeGraph.make
    graph.addDependency(Book.type, Person.type)
    graph.addDependency(Person.type, Book.type)
    try
    {
      graph.sort
    }
    catch(Err e)
    {
      verify(e.message.startsWith("Cycle detected"),
             "Incorrect exception: " + e.message)
    }
    
    graph = TypeGraph.make
    graph.addDependency(Book.type, Person.type)
    graph.addDependency(Person.type, Chapter.type)
    graph.addDependency(Chapter.type, Book.type)
    try
    {
      graph.sort
    }
    catch(Err e)
    {
      verify(e.message.startsWith("Cycle detected"),
             "Incorrect exception: " + e.message)
    }
  }
}
