//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Dec 06  Andy Frank  Creation
//

#include <stdio.h>
#include <mscoree.h>
#include <Windows.h>
#include "launcher.h"
#include "utils.h"

//////////////////////////////////////////////////////////////////////////
// .NET Main
//////////////////////////////////////////////////////////////////////////

int runNet()
{
  ICLRRuntimeHost *pClrHost;
  HRESULT hr = CorBindToRuntimeEx(
    NULL,                  // desired CLR version (NULL = latest)
    NULL,                  // desired GC flavor (NULL = workstation)
    0,                     // desired startup flags
    CLSID_CLRRuntimeHost,  // CLSID of CLR
    IID_ICLRRuntimeHost,   // IID of ICLRRuntimeHost
    (PVOID*)&pClrHost);    // return COM interface

  // initialize and start the CLR
  pClrHost->Start();

  // get sys path
  char sysPath[MAX_PATH];
  strcpy(sysPath, fanHome);
  strcat(sysPath, "\\lib\\net\\sys.dll");
  ULONG sz = strlen(sysPath) + 1;
  LPWSTR sysPodName = new WCHAR[sz];
  MultiByteToWideChar(CP_ACP, 0, sysPath, sz, sysPodName, sz);
  if (debug) printf("--   sysPath = %S\n", sysPodName);

  // figure out main
  char temp[256];
  sprintf(temp, "Fanx.Tools.%s", FAN_MAIN);
  sz = strlen(temp) + 1;
  LPWSTR mainClassName = new WCHAR[sz];
  MultiByteToWideChar(CP_ACP, 0, temp, sz, mainClassName, sz);
  if (debug) printf("--   fan.main = %S\n", mainClassName);

  // fanHome
  sz = strlen(fanHome) + 1;
  LPWSTR LfanHome = new WCHAR[sz];
  MultiByteToWideChar(CP_ACP, 0, fanHome, sz, LfanHome, sz);

  DWORD retVal = 0;
  hr = pClrHost->ExecuteInDefaultAppDomain(
      //sysPodName, mainClassName, L"run", L"", &retVal);
      sysPodName, mainClassName, L"run", LfanHome, &retVal);

  if (debug)
  {
    printf("--   Managed code returned %d\n", retVal);
    printf("--   HRESULT = %d\n", hr);
  }

  if (hr != 0)
  {
    printf("ERROR: Could not run %S\n", mainClassName);
    return hr;
  }

  return retVal;

  // Terminate this process (destroying the CLR loaded in it)
}

