//
// Copyright (c) 2008, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   5 Mar 08  Andy Frank  Creation
//

namespace Fan.Sys
{
  /// <summary>
  /// MmapBuf returned from File.mmap
  /// </summary>
//  public class MmapBuf : Buf
  public abstract class MmapBuf : Buf
  {
  /*
  //////////////////////////////////////////////////////////////////////////
  // Constructor
  //////////////////////////////////////////////////////////////////////////

    internal MmapBuf(File file, MappedByteBuffer mmap)
    {
      this.m_file = file;
      this.m_mmap = mmap;
      this.m_out  = new MmapBufOutStream();
      this.m_in   = new MmapBufInStream();
    }

  //////////////////////////////////////////////////////////////////////////
  // Obj
  //////////////////////////////////////////////////////////////////////////

    public Type type() { return Sys.MmapBufType; }

  //////////////////////////////////////////////////////////////////////////
  // Buf Support
  //////////////////////////////////////////////////////////////////////////

    internal override sealed long getSize()
    {
      return mmap.limit();
    }

    internal override sealed void setSize(long x)
    {
      mmap.limit((int)x);
    }

    internal override sealed long getPos()
    {
      return mmap.position();
    }

    internal override sealed void setPos(long x)
    {
      mmap.position((int)x);
    }

    internal override sealed int getByte(long pos)
    {
      return mmap.get((int)pos) & 0xff;
    }

    internal override sealed void setByte(long pos, int x)
    {
      mmap.put((int)pos, (byte)x);
    }

    internal override sealed void getBytes(long pos, byte[] dst, int off, int len)
    {
      int oldPos = mmap.position();
      mmap.position((int)pos);
      mmap.get(dst, off, len);
      mmap.position(oldPos);
    }

    internal override sealed void pipeTo(byte[] dst, int dstPos, int len)
    {
      mmap.get(dst, dstPos, len);
    }

    internal override sealed void pipeTo(OutputStream dst, long lenLong)
    {
      byte[] temp = temp();
      int len = (int)lenLong;
      int total = 0;
      while (total < len)
      {
        int n = Math.min(temp.length, len-total);
        mmap.get(temp, 0, n);
        dst.write(temp, 0, n);
        total += n;
      }
    }

    internal override sealed void pipeTo(RandomAccessFile dst, long lenLong)
    {
      byte[] temp = temp();
      int len = (int)lenLong;
      int total = 0;
      while (total < len)
      {
        int n = Math.min(temp.length, len-total);
        mmap.get(temp, 0, n);
        dst.write(temp, 0, n);
        total += n;
      }
    }

    internal override sealed void pipeTo(ByteBuffer dst, int len)
    {
      pipe(mmap, dst, len);
    }

    internal override void pipe(ByteBuffer src, ByteBuffer dst, int len)
    {
      // NIO has one lame method for bulk transfer
      // and it doesn't let us pass in a length
      byte[] temp = temp();
      int total = 0;
      while (total < len)
      {
        int n = Math.min(temp.length, len-total);
        src.get(temp, 0, n);
        dst.put(temp, 0, n);
        total += n;
      }
    }

    internal override sealed void pipeFrom(byte[] src, int srcPos, int len)
    {
      mmap.put(src, srcPos, len);
    }

    internal override sealed long pipeFrom(InputStream src, long lenLong)
    {
      byte[] temp = temp();
      int len = (int)lenLong;
      int total = 0;
      while (total < len)
      {
        int n = src.read(temp, 0, Math.min(temp.length, len-total));
        if (n < 0) return total == 0 ? -1 : total;
        mmap.put(temp, 0, n);
        total += n;
      }
      return total;
    }

    internal override sealed long pipeFrom(RandomAccessFile src, long lenLong)
    {
      byte[] temp = temp();
      int len = (int)lenLong;
      int total = 0;
      while (total < len)
      {
        int n = src.read(temp, 0, Math.min(temp.length, len-total));
        if (n < 0) return total == 0 ? -1 : total;
        mmap.put(temp, 0, n);
        total += n;
      }
      return total;
    }

    internal override sealed int pipeFrom(ByteBuffer src, int len)
    {
      pipe(src, mmap, len);
      return len;
    }

  //////////////////////////////////////////////////////////////////////////
  // Buf API
  //////////////////////////////////////////////////////////////////////////

    public override sealed Int capacity()
    {
      return size();
    }

    public override void capacity(Int x)
    {
      throw UnsupportedErr.make("mmap capacity fixed").val;
    }

    public override sealed Buf flush()
    {
      mmap.force();
      return this;
    }

    public override sealed Bool close()
    {
      // Java doesn't support closing mmap
      return Bool.True;
    }

    public override sealed Str toHex()
    {
      throw UnsupportedErr.make().val;
    }

    public override Buf toDigest(Str algorithm)
    {
      throw UnsupportedErr.make().val;
    }

  //////////////////////////////////////////////////////////////////////////
  // Utils
  //////////////////////////////////////////////////////////////////////////

    internal byte[] temp()
    {
      if (temp == null) temp = new byte[1024];
      return temp;
    }

  //////////////////////////////////////////////////////////////////////////
  // MmapBufOutStream
  //////////////////////////////////////////////////////////////////////////

    internal class MmapBufOutStream : OutStream
    {
      public override OutStream write(Int v) { return w((int)v.val); }
      public override OutStream w(int v)
      {
        mmap.put((byte)v);
        return this;
      }

      public OutStream writeBuf(Buf other, Int n)
      {
        other.pipeTo(mmap, (int)n.val);
        return this;
      }

      public OutStream flush()
      {
        MmapBuf.this.flush();
        return this;
      }
    }

  //////////////////////////////////////////////////////////////////////////
  // MmapBufInStream
  //////////////////////////////////////////////////////////////////////////

    internal class MmapBufInStream : InStream
    {
      public Int read() { int n = r(); return n < 0 ? null : Int.pos[n]; }
      public int r()
      {
        return mmap.get() & 0xff;
      }

      public Int readBuf(Buf other, Int n)
      {
        int read = other.pipeFrom(mmap, (int)n.val);
        if (read < 0) return null;
        return Int.pos(read);
      }

      public InStream unread(Int n) { return unread((int)n.val); }
      public InStream unread(int n)
      {
        mmap.put(mmap.position()-1, (byte)n);
        return this;
      }

      public Int peek()
      {
        return Int.pos[mmap.get(mmap.position())];
      }
    }

  //////////////////////////////////////////////////////////////////////////
  // Fields
  //////////////////////////////////////////////////////////////////////////

    private File m_file;
    private MappedByteBuffer m_mmap;
    private byte[] m_temp;
  */
  }
}