//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   3 Mar 06  Brian Frank  Creation
//

using Fan.Sys;

namespace Fan.TestNative
{

  /// <summary>
  /// Verify .NET native integration
  /// </summary>
  public class NativeTestPeer
  {

    public static NativeTestPeer make(NativeTest t)
    {
      NativeTestPeer peer = new NativeTestPeer();
      peer.ctorY = t.y();
      return peer;
    }

    public static Int doStaticA()
    {
      return Int.make(2006);
    }

    public static Int doStaticB(Int a, Int b)
    {
      return a.plus(b);
    }

    public Int getMyX(NativeTest t)
    {
      return t.x();
    }

    public void setMyX(NativeTest t, Int x)
    {
      t.x(x);
    }

    public Int getPeerZ(NativeTest t)
    {
      return z;
    }

    public void setPeerZ(NativeTest t, Int z)
    {
      if (t.m_peer != this) throw new System.Exception();
      this.z = z;
    }

    public Int getCtorY(NativeTest t)
    {
      return ctorY;
    }

    public Str defs1(NativeTest t, Str a) { return a; }
    public Str defs2(NativeTest t, Str a, Str b) { return Str.make(a.val+b.val);  }
    public Str defs3(NativeTest t, Str a, Str b, Str c) { return Str.make(a.val+b.val+c.val);  }

    public static Str sdefs1(Str a) { return a; }
    public static Str sdefs2(Str a, Str b) { return Str.make(a.val+b.val);  }
    public static Str sdefs3(Str a, Str b, Str c) { return Str.make(a.val+b.val+c.val);  }

    Int ctorY;  // value of y during make()
    Int z;

  }
}